; Titre : PIC COMMANDE PAS A PAS POUR MOTEUR DECLINAISON GERANT LES INTERRUPTIONS PC
; Date : 15/5 modifie le 27/5 modifie le 1/6 2004
; Auteur : GRONOFF G
; PIC utilis : PIC 16 F 84 
;   Mise en GPL le 10/5/2006
;   This program is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation; version 2 dated June, 1991.
;   This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.

;------------   Directive d' assemblage pour MPLAB   ---------------

	list	p=16f84A
#include	p16f84A.inc
	__config	H'3FF2'
;definition petit temps
#define	pt	165;
;definition nombre de boucles
#define	nb	40;
;definition grand temps->Celui qui varie
#define	gt	50;
#define	gtb3	12;
#define	gtb4	6;
#define	pas1	B'00011110';
#define	pas2	B'00011101';
#define	pas3	B'00001011';
#define	pas4	B'00000111';
#define	B1_tournp	0;
#define	B2_tournm	1;
#define	B3_freq1	2;
#define	B4_freq2	3;
#define	B7_inter1	6;
#define	B8_inter2	7;
Vpoint	equ	0x0C;
Vtest	equ	0x0D;
Vgrt	equ	0x0E;
Vatt	equ	0x0F   
Vboucle	equ	0x10;
Vbpt	equ	0x11;
VportB	equ	0x12;

Vw_temp	equ	0x13	
Vstatus_temp	equ	0x14
intermask	equ	B'10001000'

; Debut des operations :
	org	0
	goto	departnormal
; gestion des interruptions :	
	org	0x004
	;sauvegarde des registres
	movwf	Vw_temp
	swapf	STATUS,W
	movwf	Vstatus_temp
;
	movf	PORTB, W
	movwf	VportB
	comf VportB,f	;On fait le complement car la carte est en pull-down
	btfss VportB, B7_inter1
	goto tpint
	call	_tournelmoins
	goto endint
tpint:
	call _tourne

endint:
	;On restaure les registres
	swapf	Vstatus_temp,W
	movwf	STATUS
	swapf Vw_temp,f
	swapf Vw_temp,W
	retfie ;On retourne car on a fini


; Demarrage normal du programme
departnormal:

	bsf	STATUS,5		; on met  1 le 5eme bit du registre status pour accder
    				;  la 2eme page mmoire ( pour trisa et trisb )
	movlw	0xFF                           ; on met FF dans le registre W
	movwf	TRISB                         ; on met FF dans le port B il est programm en entre
	movlw	0x00                           ; on met 00 dans le registre W
	movwf	TRISA                         ; on met 00 dans le port A il est programm en sortie
	bcf	STATUS,5		; on remet  0 le 5eme bit du registre status pour accder	
				;  la 1eme page mmoire 
; initialisation du port A
	movlw  0x00              ; on met 00 dans le registre W
	movwf  PORTA          ; on met W sur le port A ( phase ) 
;initialisation de la variable temporelle
	movlw gt
	movwf Vgrt
;grt est la variable temporelle principale (on verra le chgt en fnc)
;initialisation du "pointeur" de pas 
	movlw 0x1
	movwf Vpoint

;
	movlw intermask
	movwf INTCON
	
	
	goto main	;on demarre le vrai programme

;-----------------------------------------------------
;		Sous routines
;-----------------------------------------------------
;# sous routine dec+
;------------------------------------------------------
_decplus:
	movf Vpoint, W
	movwf Vtest
	btfss Vtest, 2 ;		#on saute si 4
	goto incr     ;	#sinon incremente
	movlw 0x0
	movwf Vpoint
incr:
	incf	Vpoint, 1
	return
;------------------------------------------------------

;#sous routine dec--
;------------------------------------------------------
_decmoinsmoins:
	movf Vpoint, W
	movwf Vtest
	decfsz Vtest, f
	goto teste2
	movlw 5
	movwf Vpoint


teste2:
	decfsz Vtest, f
	goto decr
	movlw 6
	movwf Vpoint


decr:
	decf Vpoint, 1
	decf Vpoint, 1
	return
;------------------------------------------------------

;# Sous routine de chargement 
;#
;#ATTENTION IL FAUT RAJOUTER DES NOP POUR EGALISER...
;#
;------------------------------------------------------
_chargela:
	movf Vpoint, W
	movwf Vtest
	decfsz Vtest, f
	goto test2			;point=1
	movlw pas1
	movwf PORTA
	return
test2:
	decfsz Vtest, f
	goto test3			;point=2
	movlw pas2
	movwf PORTA
	return
	
test3:
	decfsz Vtest, f
	goto test4 			;point=3
	movlw pas3
	movwf PORTA
	return
test4:				;point=4
	movlw pas4
	movwf PORTA
	return
;----------------------------------------------------
;	On fait tourner les moteurs
;----------------------------------------------------
_tourne:
	call _chargela;
	call _decplus;
	return
_tournelmoins:
	call _decmoinsmoins
	call _tourne
	return



;----------------------------------------------------
;	Sous routines dattente
;----------------------------------------------------

; Sous routine stda 
_stda:
	btfss VportB, B3_freq1
	goto suite
	movlw gtb3
	movwf Vgrt
	
suite:
	btfss VportB, B4_freq2
	return
	movlw gtb4
	movwf Vgrt
	return;
;Sous routine attente
_attente:
	movf Vgrt, W
	movwf Vatt
attends:
	call _Bouclenb
	decfsz Vatt, f
	goto attends
	return	
;Sous routine _Bouclenb
_Bouclenb:
	movlw nb
	movwf Vboucle
grandeboucle:
	call _Bouclept		
	decfsz Vboucle, f
	goto grandeboucle
	return
;definition Bouclept
_Bouclept:
	movlw pt
	movwf Vbpt
petiteboucle:
	decfsz Vbpt, f
	goto petiteboucle
	return







;#################################################################################
;##										##
;##   				Programme principal				##
;##										##
;#################################################################################


main:
	
	movf	PORTB, W
	movwf	VportB

	comf VportB,f	;On fait le complement car la carte est en pull-down
	btfss VportB, B3_freq1
	goto nonpc
	btfss VportB, B4_freq2
	goto nonpc  ; on peut changer pour avoir exactement le meme nb de tops
	goto main
nonpc:
	btfsc VportB, B1_tournp
	goto incp
	btfsc VportB, B2_tournm
	goto decp  ; 
;	movlw gt
;	movwf Vgrt
;	call _attente
;	call _tourne;
	goto main;
incp:
	movlw gt
	movwf Vgrt
	call _stda ; Sous routine de dcrmentation de temps d'attente
	call _attente; On effectue le temps d'attente
	movlw gt   ; On rinitialise la variable en 2*
	movwf Vgrt ;
	call _tourne;
	goto main;
decp:
	movlw gt
	movwf Vgrt
	call _stda ; Sous routine de dcrmentation de temps d'attente
	call _attente; On effectue le temps d'attente
	
	movlw gt   ; On rinitialise la variable
	movwf Vgrt ;
	call _tournelmoins;
	goto main;
;########################################################
end








